// mfcDlg.cpp : implementation file
//
#define  _USE_MFC
#include "stdafx.h"
#include "mfc.h"
#include "mfcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
            
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcDlg dialog

CMfcDlg::CMfcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  
}

CMfcDlg::~CMfcDlg(void)
{
}

void CMfcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMfcDlg, CDialog)
	//{{AFX_MSG_MAP(CMfcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcDlg message handlers

BOOL CMfcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

  char MemoTxt[512];
  sprintf(MemoTxt,
          "dWinlock core example (c) 2002-2008 Kassl GmbH\r\n"
          "http://www.dwinlock.kassl.de\r\n"
          "dwlgina version: %i.%i\r\n\r\n",
          HIWORD(DWL_VERSION),LOWORD(DWL_VERSION));

  SendDlgItemMessage(IDC_EDIT1,WM_SETTEXT,0,(LPARAM)MemoTxt);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMfcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMfcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// dwinlock key callback
static void __stdcall dwlKeydownEvent(int UserData, HWND /*hWnd*/, int /*Down*/, int Key, int Shift)
{
  CMfcDlg *self = (CMfcDlg*)UserData;

  char MemoTxt[4096];
  char ShiftText[256];

  // get current edit text
  self->SendDlgItemMessage(IDC_EDIT1,WM_GETTEXT,4096,(LPARAM)MemoTxt);

  int n=0;
  for(char *c=MemoTxt;*c;c++) if(*c=='\n') n++; // count lines
  if(n>14)MemoTxt[97]=0; // delete lines

  // format keystate as text
  ShiftText[0]=0;
  if(Shift & MOD_CONTROL) strcat(ShiftText,"CTRL ");
  if(Shift & MOD_ALT)     strcat(ShiftText,"ALT ");
  if(Shift & MOD_SHIFT)   strcat(ShiftText,"SHIFT ");
  if(Shift & MOD_WIN)     strcat(ShiftText,"WIN");
    
  if(Key>='A' && Key<='Z' || Key>='0' && Key<='9') 
    sprintf(MemoTxt,"%s %s %c\r\n",MemoTxt,ShiftText,Key);
  else
    sprintf(MemoTxt,"%s %s 0x%2X\r\n",MemoTxt,ShiftText,Key);

  // set new edit text
  self->SendDlgItemMessage(IDC_EDIT1,WM_SETTEXT,0,(LPARAM)MemoTxt);  
}
 
void CMfcDlg::OnCheck3()  // show key strokes
{  
  if (SendDlgItemMessage(IDC_CHECK3, BM_GETSTATE,0, 0) & BST_CHECKED) {    
    wlSetKeyCallback(&dwlKeydownEvent,(int)this,kDownEvents); // set dwinlock key callback
  }else{
    wlSetKeyCallback(NULL,0,0);
  }
}

void CMfcDlg::OnCheck1() // lock windows
{	
  int disable=0;
  if (SendDlgItemMessage(IDC_CHECK1, BM_GETSTATE,0, 0) & BST_CHECKED) {
    disable=1;
  }

  wlDisableKey(0,VK_TAB,MOD_ALT,disable);

  // disables desktop items
  wlDisableItem(wlTaskTray,disable);
  wlDisableItem(wlDesktop,disable);
  wlDisableItem(wlTaskLinks,disable);
  wlDisableItem(wlStartbutton,disable);

  // find handles for task bar and start button
  HWND hTaskBar     = wlGetItemHandle(wlTaskBar);
  

  wlDisableKey(0,0,MOD_WIN,disable);              // disables all WIN keys
  wlDisableKey(0,VK_ESCAPE, MOD_CONTROL,disable);
  wlDisableKey(0,VK_F4, MOD_ALT,disable);
  // DisableKey(0,VK_TAB, MOD_ALT,disable);
  // DisableKey(0,VK_ESCAPE, MOD_ALT,disable);

  
  // disables all keys (mouse buttons included) for task bar
  wlDisableKey(hTaskBar,0, MOD_ALL,disable);

 /* statement above includes all following "disables"
    // disables start button
    wlDisableKey(hStartButton,VK_LBUTTON, MOD_ALL,disable);
    wlDisableKey(hStartButton,VK_RBUTTON, MOD_ALL,disable);

    wlDisableKey(hTaskBar,0, MOD_ALT,disable);
    wlDisableKey(hTaskBar,VK_F3, MOD_ALL,disable);
    wlDisableKey(hTaskBar,VK_RBUTTON,MOD_ALL,disable);
    wlDisableKey(hTaskBar,VK_APPS, MOD_ALL,disable);
  */

  if (wlIsDwlInstalled() == 1)          // only if dwlgina is installed
    wlDisableKey(0,VK_DELETE,MOD_CONTROL | MOD_ALT,disable); // disables Ctrl+Alt+Del
}
